Loading...
Searching...
No Matches
Sip_replaces

## Data Structures

struct | sip_replaces_s
| Structure for Replaces header. More...

## Macros

#define | sip_replaces(sip)
| Access a SIP Replaces header structure sip_replaces_t from sip_t.
#define | SIP_REPLACES_INIT()
| Initializer for structure sip_replaces_t.
#define | SIPTAG_REPLACES(x)
| Tag list item for pointer to a Replaces header structure sip_replaces_t.
#define | SIPTAG_REPLACES_REF(x)
| Tag list item for reference to a Replaces header pointer.
#define | SIPTAG_REPLACES_STR(s)
| Tag list item for string with Replaces header value.
#define | SIPTAG_REPLACES_STR_REF(x)
| Tag list item for reference to a Replaces header string.

## Typedefs

typedef struct sip_replaces_s | sip_replaces_t
| @

## Functions

issize_t | sip_replaces_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Replaces header.
issize_t | sip_replaces_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Replaces header.
sip_replaces_t * | sip_replaces_init (sip_replaces_t x[1])
| Initialize a structure sip_replaces_t.
int | sip_is_replaces (sip_header_t const *header)
| Test if header object is instance of sip_replaces_t.
sip_replaces_t * | sip_replaces_dup (su_home_t *home, sip_replaces_t const *hdr))
| Duplicate a list of Replaces header header structures sip_replaces_t.
sip_replaces_t * | sip_replaces_copy (su_home_t *home, sip_replaces_t const *hdr))
| Copy a list of Replaces header header structures sip_replaces_t.
sip_replaces_t * | sip_replaces_make (su_home_t *home, char const *s))
| Make a Replaces header structure sip_replaces_t.
sip_replaces_t * | sip_replaces_format (su_home_t *home, char const *fmt,...)))
| Make a Replaces header from formatting result.

## Variables

msg_hclass_t | sip_replaces_class []
| Header class for Replaces header.
tag_typedef_t | siptag_replaces
| Tag for Replaces header object.
tag_typedef_t | siptag_replaces_str
| Tag for string with Replaces header value.

## Detailed Description

## Macro Definition Documentation

## SIP_REPLACES_INIT

#define SIP_REPLACES_INIT | ( |  | ) |

Initializer for structure sip_replaces_t.

A static sip_replaces_t structure for Replaces header must be initialized with the SIP_REPLACES_INIT() macro. For instance,

sip_replaces_t sip_replaces = SIP_REPLACES_INIT;
sip_replaces
#define sip_replaces(sip)
Access a SIP Replaces header structure sip_replaces_t from sip_t.
Definition sip_protos.h:11793
sip_replaces_t
struct sip_replaces_s sip_replaces_t
@
Definition sip.h:177
SIP_REPLACES_INIT
#define SIP_REPLACES_INIT()
Initializer for structure sip_replaces_t.
Definition sip_protos.h:11810

## SIPTAG_REPLACES

#define SIPTAG_REPLACES | ( |  | x | ) |

Tag list item for pointer to a Replaces header structure sip_replaces_t.

The SIPTAG_REPLACES() macro is used to include a tag item with a pointer to a sip_replaces_t structure in a tag list.

Parameters

  x | pointer to a sip_replaces_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_REPLACES_REF().

## SIPTAG_REPLACES_STR

#define SIPTAG_REPLACES_STR | ( |  | s | ) |

Tag list item for string with Replaces header value.

The SIPTAG_REPLACES_STR() macro is used to include a tag item with a string containing value of a sip_replaces_t header in a tag list.

Parameters

  s | pointer to a string containing Replaces header value, or NULL.

The string in SIPTAG_REPLACES_STR() can be converted to a sip_replaces_t header structure by giving the string s has second argument to function sip_replaces_make().

The corresponding tag taking reference parameter is SIPTAG_REPLACES_STR_REF().

## Typedef Documentation

## sip_replaces_t

typedef struct sip_replaces_s sip_replaces_t

@

The Replaces header indicates that a single dialog identified by the header field is to be shut down and logically replaced by the incoming INVITE in which it is contained. Its syntax is defined in RFC 3891 section 6.1 as follows:

Replaces = "Replaces" HCOLON callid *(SEMI replaces-param)
replaces-param = to-tag / from-tag / early-flag / generic-param
to-tag = "to-tag" EQUAL token
from-tag = "from-tag" EQUAL token
early-flag = "early-only"

A Replaces header field MUST contain exactly one <to-tag> and exactly one <from-tag>, as they are required for unique dialog matching. For compatibility with dialogs initiated by RFC 2543 compliant UAs, a tag of zero ("0") matches both tags of zero and null. A Replaces header field MAY contain the <early-only> flag.

The parsed Replaces header is stored in sip_replaces_t structure.

See also
  RFC 3891, nta_leg_by_replaces(), nta_leg_make_replaces()

The structure sip_replaces_t contains representation of Replaces header.

The sip_replaces_t is defined as follows:

typedef struct sip_replaces_s
{
sip_common_t rp_common[1]; // Common fragment info
sip_error_t *rp_next; // Dummy link to next
char const *rp_call_id; // @CallID of dialog to replace
msg_param_t const *rp_params; // List of parameters
char const *rp_to_tag; // Value of "to-tag" parameter
char const *rp_from_tag; // Value of "from-tag" parameter
unsigned rp_early_only; // early-only parameter
} sip_replaces_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_replaces_s
Structure for Replaces header.
Definition sip.h:618
sip_replaces_s::rp_next
sip_error_t * rp_next
Link to next (dummy).
Definition sip.h:620
sip_replaces_s::rp_early_only
unsigned rp_early_only
early-only parameter
Definition sip.h:625
sip_replaces_s::rp_common
sip_common_t rp_common[1]
Common fragment info.
Definition sip.h:619
sip_replaces_s::rp_call_id
char const * rp_call_id
Call-ID of dialog to replace
Definition sip.h:621
sip_replaces_s::rp_from_tag
char const * rp_from_tag
Value of "from-tag" parameter.
Definition sip.h:624
sip_replaces_s::rp_to_tag
char const * rp_to_tag
Value of "to-tag" parameter.
Definition sip.h:623
sip_replaces_s::rp_params
msg_param_t const * rp_params
List of parameters.
Definition sip.h:622

## Function Documentation

## sip_is_replaces()

int sip_is_replaces | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_replaces_t.

Check if the header class is an instance of Replaces header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header replaces
  0 | (false) otherwise

## sip_replaces_copy()

sip_replaces_t * sip_replaces_copy | ( | su_home_t * | home,
|  | sip_replaces_t const * | hdr )

inline

Copy a list of Replaces header header structures sip_replaces_t.

The function sip_replaces_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  replaces = sip_replaces_copy(home, sip->sip_replaces);
  sip_replaces_copy
  sip_replaces_t * sip_replaces_copy(su_home_t *home, sip_replaces_t const *hdr))
  Copy a list of Replaces header header structures sip_replaces_t.
  Definition sip_protos.h:11940

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_replaces_dup()

sip_replaces_t * sip_replaces_dup | ( | su_home_t * | home,
|  | sip_replaces_t const * | hdr )

inline

Duplicate a list of Replaces header header structures sip_replaces_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  replaces = sip_replaces_dup(home, sip->sip_replaces);
  sip_replaces_dup
  sip_replaces_t * sip_replaces_dup(su_home_t *home, sip_replaces_t const *hdr))
  Duplicate a list of Replaces header header structures sip_replaces_t.
  Definition sip_protos.h:11897

Returns
  A pointer to the newly duplicated sip_replaces_t header structure, or NULL upon an error.

## sip_replaces_format()

sip_replaces_t * sip_replaces_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Replaces header from formatting result.

Make a new sip_replaces_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_replaces_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_replaces_init()

sip_replaces_t * sip_replaces_init | ( | sip_replaces_t | x[1] | ) |

inline

Initialize a structure sip_replaces_t.

An sip_replaces_t structure for Replaces header can be initialized with the sip_replaces_init() function/macro. For instance,

sip_replaces_t sip_replaces;
sip_replaces_init(&sip_replaces);
sip_replaces_init
sip_replaces_t * sip_replaces_init(sip_replaces_t x[1])
Initialize a structure sip_replaces_t.
Definition sip_protos.h:11828

## sip_replaces_make()

sip_replaces_t * sip_replaces_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Replaces header structure sip_replaces_t.

The function sip_replaces_make() makes a new sip_replaces_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_replaces_t header structure, or NULL upon an error.

## Variable Documentation

## sip_replaces_class

msg_hclass_t sip_replaces_class[]

extern

Header class for Replaces header.

The header class sip_replaces_class defines how a SIP Replaces header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_replaces_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.